#include "Assignment.h"

Assignment *Assignment::a_instance(){
        if (!instance)
          instance = new Assignment;
        return instance;
}

void Assignment::setVarKeys(vector<int> v) {
	variables = v;
}

void Assignment::setAssignment(int variable, int value) {
	assign[variable] = value;
}

int Assignment::getAssignment(int variable) {
	return assign[variable];
}

bool Assignment::isComplete() {
	return everyVariableIsAKeyAndHasAValue();
}

bool Assignment::everyVariableIsAKeyAndHasAValue() {
	map<int, int>::iterator p;
	
	for (int i = 0; i < int(variables.size()); i++) {
		p = assign.find(variables[i]);
		
		if (p == assign.end())
	       return false;
	}
	return true;
}

void Assignment::remove(int variable) {
	assign.erase(variable);
}

int Assignment::selectFirstUnassignedVariable() {
	vector<int>::iterator p;
	map<int, int>::iterator m;
	int temp;

	for (p = variables.begin(); p != variables.end(); p++) {
		temp = *p;
		m = assign.find(temp);
		if (m == assign.end())	/* no assignment for variable temp */
			return temp;
	}
	return 0;
}

vector<int> Assignment::selectAllUnassignedVariables() {
	vector<int>::iterator p;
	map<int, int>::iterator m;
	int temp;
	vector<int> vars;

	for (p = variables.begin(); p != variables.end(); p++) {
		temp = *p;
		m = assign.find(temp);
		if (m == assign.end())
			vars.push_back(temp);
	}
	return vars;
}

vector<int> Assignment::selectAllAssignedVariables() {
	vector<int>::iterator p;
	map<int, int>::iterator m;
	int temp;
	vector<int> vars;

	for (p = variables.begin(); p != variables.end(); p++) {
		temp = *p;
		m = assign.find(temp);
		if (m != assign.end())	
			vars.push_back(temp);
	}
	return vars;
}

bool Assignment::hasAssignmentFor(int variable) {
	map<int, int>::iterator m;
	
	m = assign.find(variable);

	if (m != assign.end())
		return true;
	else
		return false;
}

void Assignment::print() {	
	for (int i = 0; i < int(variables.size()); i++) 
		cout << "variable " << variables[i] << " has value " << assign[variables[i]] << endl;	
}

void Assignment::reset() {
        assign.clear();
        variables.clear();
} 
